## kdevelop 25.08.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Gear version, managed by release service script
set(RELEASE_SERVICE_VERSION_MAJOR "25")
set(RELEASE_SERVICE_VERSION_MINOR "08")
set(RELEASE_SERVICE_VERSION_MICRO "3")

set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# generate patch level from release service version
set(_micro ${RELEASE_SERVICE_VERSION_MICRO})
if (_micro LESS "10")
    string(PREPEND _micro "0") # pad with 0
endif()
set(RELEASE_SERVICE_BASED_PATCHLEVEL "${RELEASE_SERVICE_VERSION_MAJOR}${RELEASE_SERVICE_VERSION_MINOR}${_micro}")

# The math expression below automatically increments KDevelop minor version in each KDE Gear release.
# The multiplier 3 is the number of releases that share ${RELEASE_SERVICE_VERSION_MAJOR}.
# The fraction assigns consecutive minor versions to the 3 releases - 04, 08 and 12. The rounding up groups
# pre-release versions with the corresponding final release versions: 03 with 04, 07 with 08 and 11 with 12.
# The final subtrahend at the end of the expression ensures version continuity: KDevelop 6.0 in KDE Gear 24.08.
math(EXPR KDEVELOP_OWN_MINOR_VERSION "${RELEASE_SERVICE_VERSION_MAJOR} * 3                  \
                                      + (${RELEASE_SERVICE_VERSION_MINOR} + 4 - 3) / 4      \
                                      - 74")

# On macOS KDevelop_VERSION_MINOR is modified below. But KDEV_ITEMREPOSITORY_VERSION should depend on the
# original minor version on all platforms. So the variable ${KDEVELOP_OWN_MINOR_VERSION} is used again later.
project(KDevelop VERSION "6.${KDEVELOP_OWN_MINOR_VERSION}.${RELEASE_SERVICE_BASED_PATCHLEVEL}")

# KDevelop SOVERSION
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVELOP_SOVERSION "${KDevelop_VERSION_MAJOR}${KDevelop_VERSION_MINOR}")

if (APPLE)
    ###################################################################################
    # Kludge for bug #448152: ld: malformed 64-bit a.b.c.d.e version number: 5.7.211201
    # Apple's linker uses the project version (not the SOVERSION) to calculate an
    # unsigned int in such a way that places restrictions on the magnitude of each tier
    # of the version string.
    # See here: https://www.sicpers.info/2013/03/how-to-version-a-mach-o-library/
    ###################################################################################
    project(KDevelop VERSION "${KDevelop_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${_micro}")
endif()

# plugin version as used e.g. in plugin installation path
set(KDEV_PLUGIN_VERSION "${KDEVELOP_SOVERSION}")

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.0.0")

option(BUILD_DOC "Whether to build the documentation" ON)

# we need some parts of the ECM CMake helpers
find_package (ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE) # needs to be first, as set policies influence following macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(KDevelopMacrosInternal)

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS
    Concurrent
    Core5Compat
    DBus
    Quick
    QuickWidgets
    Widgets
)
if(BUILD_TESTING)
  find_package(Qt6Test ${QT_MIN_VERSION} REQUIRED)
endif()

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
  Config
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  NotifyConfig
  Parts
  Service
  TextEditor
  ThreadWeaver
  XmlGui
  WindowSystem
  Crash
  GuiAddons
  Archive
  Notifications
  Sonnet
  TextTemplate
  TextWidgets
)
if(BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION} REQUIRED)
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif()

set(HAVE_KSYSGUARD FALSE)
find_package(KSysGuard CONFIG QUIET)
set_package_properties(KSysGuard PROPERTIES
    PURPOSE "Framework for process listing. Required for the 'Attach to Process' feature"
    TYPE RECOMMENDED
)
if(KSysGuard_FOUND)
    set(HAVE_KSYSGUARD TRUE)
endif()

find_package(KDevelopPGQt 2.4 QUIET) # TODO (once we require KDevelopPGQt version 2.4 or later): remove QUIET again
set_package_properties(KDevelopPGQt PROPERTIES
    PURPOSE "KDevelop parser generator library. Required for the QMake Builder/Manager plugin."
    TYPE RECOMMENDED
)
if (NOT KDevelopPGQt_FOUND)
    find_package(KDevelop-PG-Qt 2.3)
    set_package_properties(KDevelop-PG-Qt PROPERTIES
        PURPOSE "KDevelop parser generator library (older name & version). Required for the QMake Builder/Manager plugin."
        TYPE RECOMMENDED
    )
endif()

find_package(SharedMimeInfo 1.9 REQUIRED)

# added by KDE_COMPILERSETTINGS_LEVEL 5.85.0
remove_definitions(
    -DQT_NO_KEYWORDS
)
add_definitions(
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
)
ecm_set_disabled_deprecation_versions(
    DISABLE_NEWER_WARNINGS # remove again once Qt6/KF6 porting work fully done
    QT ${QT_MIN_VERSION}
    KF ${KF_MIN_VERSION}
)

# Globally enable PIC since static libraries need it for Qt staticMetaObject
# Furthermore, without that we cannot easily compile with ASAN either
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Turn off missing-field-initializers warning for GCC to avoid noise from false positives with empty {}
# See discussion: https://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
add_compile_flag_if_supported(-Wno-missing-field-initializers)
add_compile_flag_if_supported(-Werror=switch)
add_compile_flag_if_supported(-Werror=undefined-bool-conversion)
add_compile_flag_if_supported(-Werror=tautological-undefined-compare)
add_compile_flag_if_supported(-Werror=implicit-fallthrough)    # Use [[fallthrough]] for false positives.
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-Wdocumentation)
    add_compile_flag_if_supported(-Wcovered-switch-default)
    add_compile_flag_if_supported(-Wunreachable-code-break)
    # This warning is triggered by every call to qCDebug()
    add_compile_flag_if_supported(-Wno-gnu-zero-variadic-macro-arguments)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-pedantic)
    add_compile_flag_if_supported(-Wzero-as-null-pointer-constant CXX_ONLY)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_flag_if_supported(-Wsuggest-override CXX_ONLY)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_ENABLED OFF)
else()
  set(COMPILER_OPTIMIZATIONS_ENABLED ON)
endif()

option(BUILD_BENCHMARKS "Whether benchmarks should be compiled or not" ${COMPILER_OPTIMIZATIONS_ENABLED})

# create config-kdevelop.h
configure_file(config-kdevelop.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kdevelop.h)
include_directories(${KDevelop_BINARY_DIR}) # for config-kdevelop.h

add_subdirectory(3rdparty/timsort)

add_subdirectory(kdevplatform)
add_subdirectory(plugins)

add_subdirectory(pics)
add_subdirectory(app)
add_subdirectory(app_templates)
add_subdirectory(file_templates)
add_subdirectory(shortcuts)
add_subdirectory(share)

if(BUILD_DOC)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop")
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelopConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
                                  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(PROJECT
                  VARIABLE_PREFIX KDEVELOP
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install(EXPORT KDevelopTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" NAMESPACE KDev:: FILE KDevelopTargets.cmake)

# kdebugsettings file
install_qt_logging_categories(TYPE APP_PLUGIN)

install(FILES org.kde.kdevelop.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# Make it possible to use the po files fetched by the fetch-translations step
ki18n_install(po)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== plugins/filetemplates/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevfiletemplates\")
set(kdevfiletemplates_PART_SRCS
    templatepreview.cpp
    templatepreviewtoolview.cpp
    filetemplatesplugin.cpp

    ipagefocus.cpp
    classidentifierpage.cpp
    classmemberspage.cpp
    defaultcreateclasshelper.cpp
    licensepage.cpp
    outputpage.cpp
    overridespage.cpp
    templateclassassistant.cpp
    templateoptionspage.cpp
    templateselectionpage.cpp
    testcasespage.cpp
)

declare_qt_logging_category(kdevfiletemplates_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_FILETEMPLATES
    CATEGORY_BASENAME "filetemplates"
)

ki18n_wrap_ui(kdevfiletemplates_PART_SRCS
    templatepreviewtoolview.ui
    ui/licensechooser.ui
    ui/newclass.ui
    ui/outputlocation.ui
    ui/overridevirtuals.ui
    ui/templateselection.ui
    ui/testcases.ui
)

install(FILES kdevfiletemplates.knsrc  DESTINATION ${KDE_INSTALL_KNSRCDIR})
qt_add_resources(kdevfiletemplates_PART_SRCS kdevfiletemplates.qrc)

kdevplatform_add_plugin(kdevfiletemplates SOURCES ${kdevfiletemplates_PART_SRCS})

target_link_libraries(kdevfiletemplates
    KDev::Interfaces
    KDev::Language
    KDev::Project
    KDev::Util
    KF6::NewStuffWidgets
    KF6::TextEditor
    KF6::Service
    KF6::KIOWidgets
    KF6::TextWidgets
)

########### install files ###############

install(FILES
licenses/GPL\ v2
licenses/GPL\ v3
licenses/LGPL\ v2
licenses/LGPL\ v3
licenses/Apache\ v2
licenses/BSD
licenses/Boost
licenses/MIT\ X11
licenses/Mozilla\ v1.1
"licenses/LGPL v2+ (KDE)"
"licenses/GPL v2+ (KDE)"
DESTINATION ${KDE_INSTALL_DATADIR}/kdevcodegen/licenses
)


################

set(test_srcs
main.cpp
    templatepreview.cpp

    ipagefocus.cpp
    classidentifierpage.cpp
    classmemberspage.cpp
    defaultcreateclasshelper.cpp
    licensepage.cpp
    outputpage.cpp
    overridespage.cpp
    templateclassassistant.cpp
    templateoptionspage.cpp
    templateselectionpage.cpp
    testcasespage.cpp
    debug.cpp
)

if(BUILD_TESTING)
    add_executable(testfiletemplates ${test_srcs})
    add_dependencies(testfiletemplates kdevfiletemplates)
    target_link_libraries(testfiletemplates
        KDev::Interfaces
        KDev::Language
        KDev::Project
        KDev::Util
        KDev::Tests
        KF6::KIOWidgets
        KF6::TextWidgets
        KF6::NewStuffWidgets
    )

    add_subdirectory(tests)
endif()

=== plugins/okteta/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevokteta\")

SET( kdevokteta_PART_SRCS
    kastentoolviewwidget.cpp
    oktetatoolviewfactory.cpp
    oktetaplugin.cpp
    oktetadocument.cpp
    oktetaview.cpp
    oktetawidget.cpp
)

qt_add_resources(kdevokteta_PART_SRCS kdevokteta.qrc)
kdevplatform_add_plugin(kdevokteta SOURCES
	${kdevokteta_PART_SRCS})

TARGET_LINK_LIBRARIES( kdevokteta
    KDev::Interfaces
    KDev::Project
    KDev::Sublime
    KDev::Shell
    KF6::WidgetsAddons
    OktetaKastenControllers
    KastenControllers
)

=== plugins/scratchpad/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevscratchpad\")
set(scratchpad_SRCS
    scratchpad.cpp
    scratchpadview.cpp
    scratchpadjob.cpp
)

ki18n_wrap_ui(scratchpad_SRCS scratchpadview.ui)

qt_add_resources(scratchpad_SRCS kdevscratchpad.qrc)

declare_qt_logging_category(scratchpad_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_SCRATCHPAD
    CATEGORY_BASENAME "scratchpad"
)

kdevplatform_add_plugin(scratchpad
    SOURCES ${scratchpad_SRCS}
)

target_link_libraries(scratchpad
    KDev::Interfaces
    KDev::Sublime
    KDev::Util
    KDev::OutputView
)

=== plugins/subversion/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevsubversion\")

# silence the deprecation warnings
# if someone wants to fix the code, I'd welcome it
# but for now, we won't spend time on it...
add_definitions(-DSVN_DEPRECATED=)

kde_enable_exceptions()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
add_subdirectory(3rdparty)
add_subdirectory(icons)

set(kdevsubversion_JOB_SRCS
    svninternaljobbase.cpp
    svnjobbase.cpp
    svncommitjob.cpp
    svnstatusjob.cpp
    svnaddjob.cpp
    svnupdatejob.cpp
    svnrevertjob.cpp
    svnremovejob.cpp
    svninfojob.cpp
    svndiffjob.cpp
    svncopyjob.cpp
    svnmovejob.cpp
    svnlogjob.cpp
    svnblamejob.cpp
    svnimportjob.cpp
    svncheckoutjob.cpp
)

set(kdevsubversion_PART_SRCS
    kdevsvnplugin.cpp
    svnssldialog.cpp
    svnimportmetadatawidget.cpp
    svnclient.cpp
    svnlocationwidget.cpp
)

declare_qt_logging_category(kdevsubversion_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_SVN
    CATEGORY_BASENAME "svn"
)

set(kdevsubversion_PART_UI
    ui/ssltrustdialog.ui
    ui/importmetadatawidget.ui
)

ki18n_wrap_ui(kdevsubversion_PART_SRCS ${kdevsubversion_PART_UI})

kdevplatform_add_plugin(kdevsubversion SOURCES ${kdevsubversion_PART_SRCS} ${kdevsubversion_JOB_SRCS})
target_link_libraries(kdevsubversion
    KF6::KIOWidgets
    KF6::TextEditor
    KF6::ThreadWeaver
    KF6::Parts
    KF6::TextWidgets
    KDev::Interfaces
    KDev::Vcs
    KDev::OutputView
    KDev::Project
    kdevsvncpp
)

install(PROGRAMS org.kde.kdevelop_svn.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== kdevplatform/sublime/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

set(test_areaoperation_SRCS test_areaoperation.cpp areaprinter.cpp)
ecm_add_test(${test_areaoperation_SRCS}
    TEST_NAME test_areaoperation
    LINK_LIBRARIES Qt::Test KF6::I18n KF6::Parts KDev::Sublime)


set(test_areawalker_SRCS test_areawalker.cpp areaprinter.cpp)
ecm_add_test(${test_areawalker_SRCS}
    TEST_NAME test_areawalker
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_view.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_document.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_controller.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_viewactivation.cpp
    LINK_LIBRARIES Qt::Test KF6::I18n KF6::Parts KDev::Sublime)

ecm_add_test(test_aggregatemodel.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_toolviewtoolbar.cpp
    LINK_LIBRARIES Qt::Test KF6::I18n KF6::Parts KDev::Sublime)

=== plugins/astyle/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)

set(test_astyle_SRCS test_astyle.cpp
  ../astyle_formatter.cpp
  ../astyle_stringiterator.cpp
    ${kdevastyle_LOG_SRCS}
)

ecm_add_test(${test_astyle_SRCS}
    TEST_NAME test_astyle
    LINK_LIBRARIES astylelib Qt::Test KDev::Interfaces KDev::Util)

=== plugins/gdb/unittests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

ecm_add_test(test_gdb.cpp
    LINK_LIBRARIES
        kdevgdb_static
        kdevdbg_testhelper
        KDev::Tests
        Qt::Test
)

ecm_add_test(test_gdbprinters.cpp
    LINK_LIBRARIES
        Qt::Core
        Qt::Test
        kdevdebuggercommon
)

=== plugins/grepview/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

include_directories(
    ..
    ${CMAKE_CURRENT_BINARY_DIR}/..
)
set(findReplaceTest_SRCS 
    test_findreplace.cpp
    ../grepviewplugin.cpp
    ../grepdialog.cpp
    ../grepoutputmodel.cpp
    ../grepoutputdelegate.cpp
    ../grepjob.cpp
    ../grepfindthread.cpp
    ../grepoutputview.cpp
    ../greputil.cpp
    ${kdevgrepview_LOG_PART_SRCS}
)
set(kdevgrepview_PART_UI
    ../grepwidget.ui
    ../grepoutputview.ui
)

ki18n_wrap_ui(findReplaceTest_SRCS ${kdevgrepview_PART_UI})
ecm_add_test(${findReplaceTest_SRCS}
    TEST_NAME test_findreplace
    LINK_LIBRARIES Qt::DBus Qt::Test KDev::Language KDev::Project KDev::Util KDev::Tests KF6::Codecs KF6::TextWidgets KF6::KIOWidgets
    GUI)

=== plugins/qthelp/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)

configure_file(testqthelpconfig.h.in testqthelpconfig.h)

set(test_qthelpplugin_SRCS
    test_qthelpplugin.cpp
    ../qthelpplugin.cpp
    ../qthelpproviderabstract.cpp
    ../qthelpprovider.cpp
    ../qthelpdocumentation.cpp
    ../qthelpqtdoc.cpp
    ../qthelp_config_shared.cpp
    ../qthelpconfig.cpp
    ${kdevqthelp_LOG_SRCS}
)
ki18n_wrap_ui(test_qthelpplugin_SRCS
   ../qthelpconfig.ui
   ../qthelpconfigeditdialog.ui
)


ecm_add_test(${test_qthelpplugin_SRCS}
    TEST_NAME test_qthelpplugin
    LINK_LIBRARIES Qt::Test KF6::NewStuffWidgets KF6::KIOWidgets KF6::TextEditor KF6::IconWidgets Qt::Help KDev::Tests KDev::Documentation
)

=== plugins/quickopen/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

add_library(quickopentestbase STATIC
    quickopentestbase.cpp
    ../projectfilequickopen.cpp)

target_link_libraries(quickopentestbase PUBLIC
    KDev::Tests
    KDev::Project
    KDev::Language
    gfx::timsort
    Qt::Test
)

ecm_add_test(test_quickopen.cpp LINK_LIBRARIES quickopentestbase)

if(BUILD_BENCHMARKS)
    ecm_add_test(bench_quickopen.cpp LINK_LIBRARIES quickopentestbase)
    set_tests_properties(bench_quickopen PROPERTIES TIMEOUT 30)
endif()

=== plugins/subversion/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

ecm_add_test(test_svnrecursiveadd.cpp LINK_LIBRARIES
    Qt::Test Qt::Gui
    KDev::Tests KDev::Util KDev::Vcs
)

ecm_add_test(test_svnimport.cpp LINK_LIBRARIES
    Qt::Test Qt::Gui
    KDev::Tests KDev::Util KDev::Vcs
)

=== debian/changelog ===
kdevelop (4:25.08.3-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Nov 2025 15:23:10 +0000

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: bash-completion,
               clang (>= 1:6.0),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-qmldeps,
               extra-cmake-modules (>= 6.0.0~),
               kdevelop-pg-qt (>= 2.3~),
               libastyle-dev (>= 3.1),
               libboost-dev (>= 1.35.0~),
               libclang-dev,
               libkf6archive-dev (>= 6.0.0~),
               libkf6config-dev (>= 6.0.0~),
               libkf6crash-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6iconthemes-dev (>= 6.0.0~),
               libkf6itemmodels-dev (>= 6.0.0~),
               libkf6itemviews-dev (>= 6.0.0~),
               libkf6jobwidgets-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6newstuff-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6notifyconfig-dev (>= 6.0.0~),
               libkf6parts-dev (>= 6.0.0~),
               libkf6purpose-dev,
               libkf6runner-dev,
               libkf6service-dev (>= 6.0.0~),
               libkf6sonnet-dev (>= 6.0.0~),
               libkf6texteditor-dev (>= 6.0.0~),
               libkf6texttemplate-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libkf6threadweaver-dev (>= 6.0.0~),
               libkf6windowsystem-dev (>= 6.0.0~),
               libkf6xmlgui-dev (>= 6.0.0~),
               libkomparediff2-dev (>= 4:25.08.3~),
               libksysguard-dev,
               libplasma-dev,
               libsvn-dev,
               llvm-dev,
               pkgconf,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-tools-dev,
               qt6-webengine-dev,
               shared-mime-info (>= 1.9~),
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.kdevelop.org/
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop

Package: kdevelop63-libs
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevelop
Architecture: amd64 arm64 armhf
Depends: kdevelop-data (>= ${source:Version}),
         kdevelop63-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: g++,
            gcc,
            gdb (>= 7.0),
            kapptemplate,
            kio-extras,
            make,
            ${kdevelop:clang},
Suggests: clang,
          clang-tidy,
          clazy,
          cmake (>= 3.16~),
          cppcheck,
          git,
          heaptrack [linux-any],
          kdevelop-l10n,
          konsole,
          meson,
          ninja-build,
Description: integrated development environment for C/C++ and other languages
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends},
Description: data files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: amd64 arm64 armhf
Depends: kdevelop63-libs (= ${binary:Version}),
         libboost-dev (>= 1.35.0~),
         libkf6config-dev (>= 6.0.0~),
         libkf6guiaddons-dev (>= 6.0.0~),
         libkf6i18n-dev (>= 6.0.0~),
         libkf6iconthemes-dev (>= 6.0.0~),
         libkf6kio-dev (>= 6.0.0~),
         libkf6parts-dev (>= 6.0.0~),
         libkf6texteditor-dev (>= 6.0.0~),
         libkf6threadweaver-dev (>= 6.0.0~),
         qt6-5compat-dev (>= 6.5.0~),
         qt6-base-dev (>= 6.5.0~),
         qt6-declarative-dev (>= 6.5.0~),
         qt6-webengine-dev,
         ${misc:Depends},
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends},
Description: localization files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: amd64 arm64 armhf
Depends: kdevelop (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

## kdevelop 25.08.3+p24.04+vunstable+git20251203.1101

=== debian/changelog ===
kdevelop (4:25.08.3+p24.04+vunstable+git20251203.1101-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 03 Dec 2025 11:01:09 +0000

kdevelop (4:25.08.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 07 Nov 2025 00:47:00 +1000

## kdevelop 25.08.3+p24.04+vunstable+git20251204.0025

=== plugins/debuggercommon/tests/debuggees/CMakeLists.txt ===
function(add_debuggable_executable target)
    cmake_parse_arguments(add_debuggable_executable "" "" "SRCS" ${ARGN})
    add_executable(${target} ${add_debuggable_executable_SRCS})
	ecm_mark_nongui_executable(${target})
    # force debug symbols for our debuggees, disable optimizations
    if (WIN32)
        # Avoid "cl : Command line warning D9025 : overriding '/O2' with '/Od'" warnings
        # Thus set COMPILE_FLAGS_RELEASE instead of COMPILE_FLAGS
        # COMPILE_FLAGS_DEBUG should already have the desired flags
        set_target_properties(${target} PROPERTIES COMPILE_FLAGS_RELEASE "/DEBUG /Od")
    else()
        # explicitly disable sanitizers, in case they got enabled globally
        set_target_properties(${target} PROPERTIES COMPILE_FLAGS "-g -O0 -fno-sanitize=address,undefined")
        set_target_properties(${target} PROPERTIES LINK_FLAGS "-g -O0 -fno-sanitize=address,undefined")
    endif()
    set_target_properties(${target} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
endfunction()

add_debuggable_executable(debuggee_debugee SRCS debugee.cpp)
add_debuggable_executable(debuggee_debugee4foo SRCS debugee4foo.cpp)
add_debuggable_executable(debuggee_debugeeslow SRCS debugeeslow.cpp)
add_debuggable_executable(debuggee_crash SRCS debugeecrash.cpp)
add_debuggable_executable(debuggee_abort SRCS debugeeabort.cpp)
add_debuggable_executable(debuggee_arithmetic_signal SRCS debugeearithmeticsignal.cpp)
add_debuggable_executable(debuggee_debugeerecursion SRCS debugeerecursion.cpp)
add_debuggable_executable(debuggee_debugeespace SRCS "debugee space.cpp")
add_debuggable_executable(debuggee_debugeemultilocbreakpoint SRCS debugeemultilocbreakpoint.cpp)
add_debuggable_executable(debuggee_debugeemultiplebreakpoint SRCS debugeemultiplebreakpoint.cpp)
add_debuggable_executable(debuggee_debugeeechoenv SRCS debugeeechoenv.cpp)
add_debuggable_executable(debuggee_debugeepath SRCS debugeepath.cpp)

add_debuggable_executable(debuggee_debugeethreads SRCS debugeethreads.cpp)
target_link_libraries(debuggee_debugeethreads Qt::Core)

add_debuggable_executable(debuggee_debugeeqt SRCS debugeeqt.cpp)
target_link_libraries(debuggee_debugeeqt Qt::Core)

add_debuggable_executable(debuggee_debugeeexception SRCS debugeeexception.cpp)
kde_target_enable_exceptions(debuggee_debugeeexception PRIVATE)

add_subdirectory(multifile)
add_subdirectory("path with space")

add_debuggable_executable(debuggee_qstring SRCS qstring.cpp)
target_link_libraries(debuggee_qstring Qt::Core)

add_debuggable_executable(debuggee_qbytearray SRCS qbytearray.cpp)
target_link_libraries(debuggee_qbytearray Qt::Core)

add_debuggable_executable(debuggee_qlistcontainer SRCS qlistcontainer.cpp)
target_link_libraries(debuggee_qlistcontainer Qt::Core Qt::Core5Compat)

add_debuggable_executable(debuggee_qmapint SRCS qmapint.cpp)
target_link_libraries(debuggee_qmapint Qt::Core)

add_debuggable_executable(debuggee_qmapstring SRCS qmapstring.cpp)
target_link_libraries(debuggee_qmapstring Qt::Core)

add_debuggable_executable(debuggee_qmapstringbool SRCS qmapstringbool.cpp)
target_link_libraries(debuggee_qmapstringbool Qt::Core)

add_debuggable_executable(debuggee_qmultimapint SRCS qmultimapint.cpp)
target_link_libraries(debuggee_qmultimapint Qt::Core)

add_debuggable_executable(debuggee_qmultimapstring SRCS qmultimapstring.cpp)
target_link_libraries(debuggee_qmultimapstring Qt::Core)

add_debuggable_executable(debuggee_qmultimapstringbool SRCS qmultimapstringbool.cpp)
target_link_libraries(debuggee_qmultimapstringbool Qt::Core)

add_debuggable_executable(debuggee_qdate SRCS qdate.cpp)
target_link_libraries(debuggee_qdate Qt::Core)

add_debuggable_executable(debuggee_qtime SRCS qtime.cpp)
target_link_libraries(debuggee_qtime Qt::Core)

add_debuggable_executable(debuggee_qdatetime SRCS qdatetime.cpp)
target_link_libraries(debuggee_qdatetime Qt::Core)

add_debuggable_executable(debuggee_qurl SRCS qurl.cpp)
target_link_libraries(debuggee_qurl Qt::Core)

add_debuggable_executable(debuggee_qhashint SRCS qhashint.cpp)
target_link_libraries(debuggee_qhashint Qt::Core)

add_debuggable_executable(debuggee_qhashstring SRCS qhashstring.cpp)
target_link_libraries(debuggee_qhashstring Qt::Core)

add_debuggable_executable(debuggee_qmultihashint SRCS qmultihashint.cpp)
target_link_libraries(debuggee_qmultihashint Qt::Core)

add_debuggable_executable(debuggee_qmultihashstring SRCS qmultihashstring.cpp)
target_link_libraries(debuggee_qmultihashstring Qt::Core)

add_debuggable_executable(debuggee_qsetint SRCS qsetint.cpp)
target_link_libraries(debuggee_qsetint Qt::Core)

add_debuggable_executable(debuggee_qsetstring SRCS qsetstring.cpp)
target_link_libraries(debuggee_qsetstring Qt::Core)

add_debuggable_executable(debuggee_qchar SRCS qchar.cpp)
target_link_libraries(debuggee_qchar Qt::Core)

add_debuggable_executable(debuggee_qpersistentmodelindex SRCS qpersistentmodelindex.cpp)
target_link_libraries(debuggee_qpersistentmodelindex Qt::Core Qt::Gui)

add_debuggable_executable(debuggee_quuid SRCS quuid.cpp)
target_link_libraries(debuggee_quuid Qt::Core)

add_debuggable_executable(debuggee_qcbor SRCS qcbor.cpp)
target_link_libraries(debuggee_qcbor Qt::Core)

add_debuggable_executable(debuggee_qjson SRCS qjson.cpp)
target_link_libraries(debuggee_qjson Qt::Core)

add_debuggable_executable(debuggee_qvariant SRCS qvariant.cpp)
target_link_libraries(debuggee_qvariant Qt::Core)

add_debuggable_executable(debuggee_qlistpod SRCS qlistpod.cpp)
target_link_libraries(debuggee_qlistpod Qt::Core)

add_debuggable_executable(debuggee_ktexteditortypes SRCS ktexteditortypes.cpp)
target_link_libraries(debuggee_ktexteditortypes Qt::Core KF6::TextEditor)

add_debuggable_executable(debuggee_kdeveloptypes SRCS kdeveloptypes.cpp)
target_link_libraries(debuggee_kdeveloptypes Qt::Core KF6::TextEditor KDev::Util)
